<template>
<div class="view-container dewfdynaeditview3 ibizsample0021-usr1114865995-wfdyna-edit-view3">
    <app-studioaction :viewTitle="$t(model.srfCaption)" viewName="ibizsample0021usr1114865995wfdynaeditview3"></app-studioaction>
    <card class='view-card  ' :disHover="true" :padding="0" :bordered="false">
<div slot='title' class="header-container">
    <span class='caption-info' :title="$t(model.srfCaption)">{{$t(model.srfCaption)}}</span>
</div>
        <div slot="extra">
            <div class='toolbar-container'>
                <tooltip :transfer="true" :max-width="600" v-for="(linkItem, index) in linkModel" :key="index">
                        <i-button @click="dynamic_toolbar_click(linkItem, $event)">
                            <span class='caption'>{{linkItem.sequenceFlowName}}</span>
                        </i-button>
                    <div slot='content'>{{linkItem.sequenceFlowName}}</div>
                </tooltip>
            </div>
        </div>
        <div class="content-container">
            <tabs :animated="false" name="datarelation" class="content-container__drtab">
                <tab-pane tab="datarelation" label="订单">
                    <component 
                        :is="activeForm.name"
                        :isautoload="true"
                        :viewState="viewState"  
                        :viewparams="viewparams" 
                        :context="context" 
                        :autosave="false" 
                        :viewtag="viewtag"
                        :showBusyIndicator="activeForm.showBusyIndicator"
                        :updateAction="activeForm.updateAction"
                        :removeAction="activeForm.removeAction"
                        :loaddraftAction="activeForm.loaddraftAction"
                        :loadAction="activeForm.loadAction"
                        :createAction="activeForm.createAction"
                        :WFSubmitAction="activeForm.WFSubmitAction"
                        :WFStartAction="activeForm.WFStartAction"
                        name="form"  
                        ref='form' 
                        @save="form_save($event)"  
                        @remove="form_remove($event)"  
                        @load="form_load($event)"  
                        @closeview="closeView($event)">
                    </component>
                </tab-pane>
                <tab-pane tab="datarelation" label="流程日志" name="dritem1">
                    <component
                        is="app-wfstep-trace-view"
                        :viewDefaultUsage="false"
                        class="view-container2"
                        appDeCodeName="IBIZSample0021"
                        :viewdata="JSON.stringify(context)"
                        :viewparam="JSON.stringify(viewparams)">
                    </component>
                </tab-pane>
            </tabs>
            
        </div>
    </card>
</div>
</template>
// 基于 @VIEW/实体工作流动态编辑视图（分页关系）/VIEW-BASE.vue.ftl 生成

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch,Inject } from 'vue-property-decorator';
import { UIActionTool, Util } from '@/utils';
import axios from 'axios';
import { AppMessageBox } from '@/utils/app-message-box/app-message-box';
import NavDataService from '@/service/app/navdata-service';
import { Subject,Subscription } from 'rxjs';
import IBIZSample0021Service from '@/service/ibizsample0021/ibizsample0021-service';
import IBIZSample0021AuthService from '@/authservice/ibizsample0021/ibizsample0021-auth-service';


import IBIZSample0021UIService from '@/uiservice/ibizsample0021/ibizsample0021-ui-service';

import AppCenterService from '@/service/app/app-center-service';


@Component({
    components: {
    },
})
export default class IBIZSample0021Usr1114865995WFDynaEditView3Base extends Vue {

    /**
     * 实体服务对象
     *
     * @type {IBIZSample0021Service}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public appEntityService: IBIZSample0021Service = new IBIZSample0021Service();

    /**
     * 实体UI服务对象
     *
     * @type IBIZSample0021UIService
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public appUIService: IBIZSample0021UIService = new IBIZSample0021UIService();
    
    /**
     * 数据变化
     *
     * @param {*} val
     * @returns {*}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    @Emit() 
    public viewDatasChange(val: any):any {
        return val;
    }

    /**
     * 传入视图上下文
     *
     * @type {string}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    @Prop() public viewdata!: string;

    /**
     * 传入视图参数
     *
     * @type {string}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    @Prop() public viewparam!: string;

    /**
     * 视图默认使用
     *
     * @type {boolean}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    @Prop({ default: true }) public viewDefaultUsage!: boolean;

    /**
     * 视图默认使用
     *
     * @type {string}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    @Inject({from:'navModel',default: 'tab'})
    public navModel!:string;

	/**
	 * 视图标识
	 *
	 * @type {string}
	 * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
	 */
	public viewtag: string = '53757392-B5A2-4E4C-84F6-99DCC4C490AB';

    /**
	 * 视图类型
	 *
	 * @type {string}
	 * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
	 */
	public viewType: string = 'DEWFDYNAEDITVIEW3';

	/**
	 * 自定义视图导航上下文集合
	 *
	 * @type {*}
	 * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
	 */
    public customViewNavContexts:any ={
    };

	/**
	 * 自定义视图导航参数集合
	 *
	 * @type {*}
	 * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
	 */
    public customViewParams:any ={
    };

    /**
     * 视图模型数据
     *
     * @type {*}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public model: any = {
        srfCaption: 'entities.ibizsample0021.views.usr1114865995wfdynaeditview3.caption',
        srfTitle: 'entities.ibizsample0021.views.usr1114865995wfdynaeditview3.title',
        srfSubTitle: 'entities.ibizsample0021.views.usr1114865995wfdynaeditview3.subtitle',
        dataInfo: ''
    }

    /**
     * 视图参数变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    @Watch('viewparam',{immediate: true, deep: true})
    onParamData(newVal: any, oldVal: any) {
        if(newVal){
            this.viewparams = {};
            if(typeof newVal == 'string') {
                Object.assign(this.viewparams, JSON.parse(this.viewparam));
            }else{
                this.viewparams = Util.deepCopy(this.viewparam);
            }
            
        } 
    }

    /**
     * 处理应用上下文变化
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    @Watch('viewdata')
    onViewData(newVal: any, oldVal: any) {
        const _this: any = this;
        
        if (!Object.is(newVal, oldVal) && _this.engine) {
            this.$nextTick(()=>{
              _this.parseViewParam();
              _this.engine.load();
            });
        } else if(!Object.is(newVal, oldVal) && _this.refresh && _this.refresh instanceof Function) {
            _this.refresh();
        }
    }

    /**
     * 容器模型
     *
     * @type {*}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public containerModel: any = {
        view_toolbar: { name: 'toolbar', type: 'TOOLBAR' },
        view_wfform_operationform: { name: 'wfform_operationform', type: 'FORM' },
        view_form: { name: 'form', type: 'FORM' },
        view_drtab: { name: 'drtab', type: 'DRTAB' },
        wflinks: [],
    };

    /**
     * 视图操作参数
     *
     * @type {*}
     * @readonly
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public viewCtx: any = {};

    /**
     * 视图刷新
     *
     * @param {*} args
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public refresh(args?: any): void {
        const refs: any = this.$refs;
        if (refs && refs.form) {
            refs.form.refresh();
        }
    }
    /**
     *  计数器刷新
     *
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }

    /**
     * 视图状态订阅对象
     *
     * @public
     * @type {Subject<{action: string, data: any}>}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public viewState: Subject<ViewState> = new Subject();
    /**
     * 工具栏模型
     *
     * @type {*}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3
     */
    public toolBarModels: any = {
    };




    /**
     * 引擎初始化
     *
     * @public
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public engineInit(): void {
    }

    /**
     * 应用导航服务
     *
     * @type {*}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public  navDataService = NavDataService.getInstance();

    /**
    * 导航服务事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
    */
    public serviceStateEvent: Subscription | undefined;

    /**
     * 门户部件状态对象
     *
     * @type {*}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    @Prop() public portletState?: any;

   /**
   * 门户部件状态事件
   *
   * @public
   * @type {(Subscription | undefined)}
   * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
   */
    public portletStateEvent: Subscription | undefined;

    /**
    * 门户部件状态事件
    *
    * @public
    * @type {(Subscription | undefined)}
    * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
    */
    public formDruipartEvent: Subscription | undefined;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public context:any = {};

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public viewparams:any = {};

    /**
     * 视图缓存数据
     *
     * @type {*}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public viewCacheData:any;


    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 解析视图参数
     *
     * @public
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public parseViewParam(inputvalue:any = null): void {
        for(let key in this.context){
            delete this.context[key];
        }
        if(this.$store.getters.getAppData() && this.$store.getters.getAppData().context){
            Object.assign(this.context,this.$store.getters.getAppData().context);
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            if(typeof this.viewdata == 'string') {
                Object.assign(this.context, JSON.parse(this.viewdata));
            }
            if(this.context && this.context.srfparentdename){
                Object.assign(this.viewparams,{srfparentdename:this.context.srfparentdename});
            }
            if(this.context && this.context.srfparentkey){
                Object.assign(this.viewparams,{srfparentkey:this.context.srfparentkey});
            }
            this.handleCustomViewData();
            return;
        }
        const path = (this.$route.matched[this.$route.matched.length - 1]).path;
        const keys: Array<any> = [];
        const curReg = this.$pathToRegExp.pathToRegexp(path, keys);
        const matchArray = curReg.exec(this.$route.path);
        let tempValue: Object = {};
        keys.forEach((item: any, index: number) => {
            if(matchArray[index + 1]){
                Object.defineProperty(tempValue, item.name, {
                    enumerable: true,
                    value: decodeURIComponent(matchArray[index + 1])
                });
            }
        });
        this.$viewTool.formatRouteParams(tempValue,this.$route,this.context,this.viewparams);
        if(inputvalue){
            Object.assign(this.context,{'ibizsample0021':inputvalue});
        }
        //初始化视图唯一标识
        Object.assign(this.context,{srfsessionid:this.$util.createUUID()});
        this.handleCustomViewData();
        //初始化导航数据
        this.initNavDataWithRoute();
    }

    /**
     * 处理自定义视图数据
     *
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
	public handleCustomViewData(){
		if(Object.keys(this.customViewNavContexts).length > 0){
			Object.keys(this.customViewNavContexts).forEach((item:any) =>{
				let tempContext:any = {};
				let curNavContext:any = this.customViewNavContexts[item];
				this.handleCustomDataLogic(curNavContext,tempContext,item);
				Object.assign(this.context,tempContext);
			})
		}
		if(Object.keys(this.customViewParams).length > 0){
			Object.keys(this.customViewParams).forEach((item:any) =>{
				let tempParam:any = {};
				let curNavParam:any = this.customViewParams[item];
				this.handleCustomDataLogic(curNavParam,tempParam,item);
				Object.assign(this.viewparams,tempParam);
			})
		}
	}

    /**
     * 处理自定义视图数据逻辑
     *
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
	public handleCustomDataLogic(curNavData:any,tempData:any,item:string){
		// 直接值直接赋值
		if(curNavData.isRawValue){
			if(Object.is(curNavData.value,"null") || Object.is(curNavData.value,"")){
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: null,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }else{
                Object.defineProperty(tempData, item.toLowerCase(), {
                    value: curNavData.value,
                    writable : true,
                    enumerable : true,
                    configurable : true
                });
            }
		}else{
			// 先从导航上下文取数，没有再从导航参数（URL）取数，如果导航上下文和导航参数都没有则为null
			if(this.context[(curNavData.value).toLowerCase()] != null){
				Object.defineProperty(tempData, item.toLowerCase(), {
					value: this.context[(curNavData.value).toLowerCase()],
					writable : true,
					enumerable : true,
					configurable : true
				});
			}else{
				if(this.viewparams[(curNavData.value).toLowerCase()] != null){
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: this.viewparams[(curNavData.value).toLowerCase()],
						writable : true,
						enumerable : true,
						configurable : true
					});
				}else{
					Object.defineProperty(tempData, item.toLowerCase(), {
						value: null,
						writable : true,
						enumerable : true,
						configurable : true
					});
				}
			}
		}
	}

    /**
     * 初始化导航数据(路由模式)
     *
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public initNavDataWithRoute(data:any = null, isNew:boolean = false,  isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && Object.is(this.navModel,"route")) ){
            this.navDataService.addNavData({id:'ibizsample0021-usr1114865995-wfdyna-edit-view3',tag:this.viewtag,srfkey:isNew ? null : this.context.ibizsample0021,title:this.$t(this.model.srfCaption),data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath});
        }
    }

    /**
     * 初始化导航数据(分页模式)
     *
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public initNavDataWithTab(data:any = null,isOnlyAdd:boolean = true, isAlways:boolean = false){
        if( isAlways || (this.viewDefaultUsage && !Object.is(this.navModel,"route")) ){
            this.navDataService.addNavDataByOnly({id:'ibizsample0021-usr1114865995-wfdyna-edit-view3',tag:this.viewtag,srfkey:this.context.ibizsample0021,title:this.$t(this.model.srfCaption),data:data,context:this.context,viewparams:this.viewparams,path:this.$route.fullPath},isOnlyAdd);
        }
    }
	

    /**
     * Vue声明周期
     *
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */    
    public afterCreated(){
        let _this:any = this;
        const secondtag = _this.$util.createUUID();
        _this.$store.commit('viewaction/createdView', { viewtag: _this.viewtag, secondtag: secondtag });
        _this.viewtag = secondtag;
        _this.parseViewParam();
        _this.serviceStateEvent = _this.navDataService.serviceState.subscribe(({ action,name, data }:{ action:string,name:any,data:any }) => {
            if(!Object.is(name,'ibizsample0021-usr1114865995-wfdyna-edit-view3')){
                return;
            }
            if (Object.is(action, 'viewrefresh')) {
                _this.$nextTick(()=>{
                    _this.parseViewParam(data);
                    if(_this.engine){
                        _this.engine.load();
                    }
                }); 
            }
        });
        if(_this.portletState){
            _this.portletStateEvent = _this.portletState.subscribe((res:any) =>{
                if(!Object.is(res.name,'IBIZSample0021Usr1114865995WFDynaEditView3')){
                    return;
                }
                if(Object.is(res.action,'refresh') && _this.refresh && _this.refresh instanceof Function){
                    _this.refresh();
                }
            })
        }
        _this.initViewCtx();
    }

    /**
     * 初始化视图操作参数
     *
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */  
    initViewCtx() {
        Object.assign(this.viewCtx, {
            app: this.$root,
            view: this,
            viewGlobal: {},
            viewNavData: {},
            viewNavContext: this.context,
            viewNavParam: this.viewparams,
            messagebox: AppMessageBox.getInstance(),
        });
        Object.assign(this.viewCtx, { appGlobal: this.$store.getters.getAppGlobal() });
        if (this.$store.getters.getRouteViewGlobal(this.context.srfsessionid)) {
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        } else {
            this.$store.commit('addRouteViewGlobal', { tag: this.context.srfsessionid, param: {} });
            Object.assign(this.viewCtx, { routeViewGlobal: this.$store.getters.getRouteViewGlobal(this.context.srfsessionid) });
        }
        if (!this.viewDefaultUsage && this.viewdata && !Object.is(this.viewdata, '')) {
            //  嵌入视图
            Object.assign(this.viewCtx, {
                topview: this.$store.getters.getView(this.context.srfsessionid)
            });
        } else {
            //  顶层视图
            this.$store.commit('addView', { tag: this.context.srfsessionid, param: this });
            Object.assign(this.viewCtx, { topview: this });
        }
    }

    /**
     * 销毁之前
     *
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public beforeDestroy() {
        this.$store.commit('viewaction/removeView', this.viewtag);

        let _this: any = this
        if (_this.serviceStateEvent) {
            _this.serviceStateEvent.unsubscribe();
        }
        if (_this.portletStateEvent) {
            _this.portletStateEvent.unsubscribe();
        }
        if (_this.formDruipartEvent) {
            _this.formDruipartEvent.unsubscribe();
        }
        if (_this.engine) {
            _this.engine.destroy();
        }
    }

    /**
     * Vue声明周期(组件初始化完毕)
     *
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public mounted() {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public afterMounted(){
        const _this: any = this;
        _this.engineInit();
            if (_this.loadModel && _this.loadModel instanceof Function) {
                _this.loadModel();
            }
            this.getWFLinkModel();
    }




    /**
     * 关闭视图
     *
     * @param {any[]} args
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public closeView(args: any[]): void {
        let _view: any = this;
        if (_view.viewdata) {
            _view.$emit('viewdataschange', Array.isArray(args)?args:[args]);
            _view.$emit('close', Array.isArray(args)?args:[args]);
        } else if (_view.$tabPageExp) {
            _view.$tabPageExp.onClose(_view.$route.fullPath);
        }
    }

    /**
     * 销毁视图回调
     *
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public destroyed(){
        this.afterDestroyed();
    }

    /**
     * 执行destroyed后的逻辑
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public afterDestroyed(){
        if (this.viewDefaultUsage) {
                let localStoreLength = Object.keys(localStorage);
                if(localStoreLength.length > 0){
                    localStoreLength.forEach((item:string) =>{
                    if(item.startsWith(this.context.srfsessionid)){
                        localStorage.removeItem(item);
                    }
                    })
                }
                if(Object.is(this.navModel,"tab")){
                    this.navDataService.removeNavDataByTag(this.viewtag);
                }
            }
            // 销毁计数器定时器
            if(this.counterServiceArray && this.counterServiceArray.length >0){
                this.counterServiceArray.forEach((item:any) =>{
                    if(item.destroyCounter && item.destroyCounter instanceof Function){
                        item.destroyCounter();
                    }
                })
            }
    }
        /**
     * 工具栏模型数据
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public linkModel:Array<any> = [];

    /**
     * 激活表单
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public activeForm:any = {};

    /**
     * 工作流附加功能类型映射关系对象
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base                
     */
    public wfAddiFeatureRef: any = {
        // 转办
        "reassign": { featureTag: "REASSIGN", action: "TransFerTask" },
        // 前加签
        "addstepbefore": { featureTag: "ADDSTEPBEFORE", action: "BeforeSign" },
        // 后加签
        "addstepafter": { featureTag: "ADDSTEPAFTER", action: "AfterSign" },
        // 回退
        "sendback": { featureTag: "SENDBACK", action: "SendBack" },
        // 抄送
        "sendcopy": { featureTag: "SENDCOPY", action: "sendCopy" },
        // 补充信息
        "supplyinfo": { featureTag: "SUPPLYINFO", action: "supplyInfo" },
        // 征求意见
        "takeadvice": { featureTag: "TAKEADVICE", action: "takeAdvice" }
    };

    /**
     * 所有表单数据
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public allForm: any = {
        "wfform_operationform": {
            name: "view_wfform_operationform",
            logicName: "操作表单",
            autosave: false,
            showBusyIndicator: true,
            updateAction: "Update",
            removeAction:"Remove",
            loaddraftAction:"GetDraft",
            loadAction:"Get",
            createAction:"Create",
            WFSubmitAction:"WFSubmit",
            WFStartAction:"WFStart"
        },
        "form": {
            name: "view_form",
            logicName: "实体工作流动态视图（分页关系）_表单",
            autosave: false,
            showBusyIndicator: true,
            updateAction: "Update",
            removeAction:"Remove",
            loaddraftAction:"GetDraft",
            loadAction:"Get",
            createAction:"Create",
            WFSubmitAction:"WFSubmit",
            WFStartAction:"WFStart"
        },
    };

    /**
     * 视图引用数据
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public viewRefData:any = {
        "WFACTION@WFDynaActionView":{viewname:"ibizsample0021-wfdyna-action-view",title:"entities.ibizsample0021.views.wfdynaactionview.caption", width: 800, height: 500},
        "WFUTILACTION@ADDSTEPAFTER":{viewname:"ibizsample0021-addstepafterwfdyna-action-view",title:"entities.ibizsample0021.views.addstepafterwfdynaactionview.caption", width: 800, height: 500},
        "WFUTILACTION@ADDSTEPBEFORE":{viewname:"ibizsample0021-addstepbeforewfdyna-action-view",title:"entities.ibizsample0021.views.addstepbeforewfdynaactionview.caption", width: 800, height: 500},
        "WFUTILACTION@REASSIGN":{viewname:"ibizsample0021-reassignwfdyna-action-view",title:"entities.ibizsample0021.views.reassignwfdynaactionview.caption", width: 800, height: 500},
        "WFUTILACTION@SENDBACK":{viewname:"ibizsample0021-sendbackwfdyna-action-view",title:"entities.ibizsample0021.views.sendbackwfdynaactionview.caption", width: 800, height: 500}
    };

    /**
     * form 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public form_load($event: any, $event2?: any) {
    }

    /**
     * form 部件 save 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public form_save($event: any, $event2?: any) {
    }
    
    /**
     * form 部件 remove 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public form_remove($event: any, $event2?: any) {
    }

    /**
     * 获取工具栏按钮
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public getWFLinkModel():Promise<any>{
        return new Promise((resolve:any, reject:any) =>{
            let datas: {} = {};
            if (Object.keys(this.viewparams).length > 0) {
                Object.assign(datas, { 'processDefinitionKey': this.viewparams.processDefinitionKey });
                Object.assign(datas, { 'taskDefinitionKey': this.viewparams.taskDefinitionKey || this.viewparams.userTaskId });
            }
            this.appEntityService.GetWFLink(JSON.parse(JSON.stringify(this.context)),datas,true).then((response:any) =>{
                if (response && response.status === 200) {
                    this.linkModel = response.data;
                    if (response.headers && response.headers['process-form']) {
                        this.computeActivedForm(response.headers['process-form']);
                    } else {
                        this.computeActivedForm(null);
                    }
                    resolve(response.data);
                }
            }).catch((response: any) => {
                if (response && response.status) {
                    this.$Notice.error({ title: '错误', desc: response.message });
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    return;
                }
            });
        });
    }

    /**
     * 计算激活表单
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public computeActivedForm(inputForm:any) {
        if (!inputForm) {
            this.activeForm = this.allForm && Object.values(this.allForm)[0];
            return;
        }
        if (this.allForm && Object.keys(this.allForm).length > 0) {
            Object.keys(this.allForm).forEach((name:string) =>{
                if (Object.is(name,`wfform_${inputForm.toLowerCase()}`)) {
                    this.activeForm = this.allForm[name];
                }
            })
        }
    }

    /**
     * 动态工具栏点击
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base
     */
    public dynamic_toolbar_click(linkItem:any, $event:any) {
        let datas: any[] = [];
        let xData: any = this.$refs.form;
        if (xData.getDatas && xData.getDatas instanceof Function) {
            datas = [...xData.getDatas()];
        }
        const submit:Function = (submitData:any,linkItem:any) =>{
            xData.wfsubmit(submitData,linkItem).then((response: any) => {
                if (!response || response.status !== 200) {
                    return;
                }
                const { data: _data } = response;
                if (this.viewdata) {
                    this.$emit('viewdataschange', [{ ..._data }]);
                    this.$emit('close');
                } else if (this.$tabPageExp) {
                    this.$tabPageExp.onClose(this.$route.fullPath);
                }
            });
        }
        const submitAction: Function = () => {
            if (linkItem && linkItem.sequenceflowview && this.viewRefData[`WFACTION@${linkItem.sequenceflowview}`]) {
                let tempContext: any = Util.deepCopy(this.context);
                Object.assign(tempContext,{ibizsample0021:datas && datas[0].srfkey});
                let tempViewParam: any = { actionView: linkItem.sequenceflowview, actionForm: linkItem.sequenceflowform };
                let targetView: any = this.viewRefData[`WFACTION@${linkItem.sequenceflowview}`];
                const appmodal = this.$appmodal.openModal({ viewname: targetView.viewname, title: (this.$t(targetView.title) as string), height: targetView.height, width: targetView.width }, tempContext, tempViewParam);
                appmodal.subscribe((result: any) => {
                    if (!result || !Object.is(result.ret, 'OK')) {
                        return;
                    }
                    let tempSubmitData: any = Util.deepCopy(datas);
                    tempSubmitData.forEach((element: any) => {
                        Object.assign(element, result.datas && result.datas[0]);
                    });
                    submit(tempSubmitData, linkItem);
                });
            } else {
                submit(datas, linkItem);
            }
        }
        if (linkItem && linkItem.type) {
            if (Object.is(linkItem.type, "finish")) {
                submitAction();
            } else {
                this.handleWFAddiFeature(linkItem, datas);
            }
        } else {
            submitAction();
        }  
    }

    /**
     * 处理工作流辅助功能
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base                
     */
    public handleWFAddiFeature(linkItem: any, data: any) {
        if (linkItem.sequenceflowform) {
            let featureTag: string = this.wfAddiFeatureRef[linkItem.type].featureTag;
            if (!featureTag) return;
            let targetView: any = this.viewRefData[`WFUTILACTION@${featureTag}`];
            if (!targetView) {
                this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: `未找到${featureTag}映射视图` });
                return;
            }
            let tempContext: any = Util.deepCopy(this.context);
            Object.assign(tempContext,{ibizsample0021:data && data[0].srfkey});
            let tempViewParam: any = { actionForm: linkItem.sequenceflowform };
            const appmodal = this.$appmodal.openModal({ viewname: targetView.viewname, title: (this.$t(targetView.title) as string), height: targetView.height, width: targetView.width }, tempContext, tempViewParam);
            appmodal.subscribe((result: any) => {
                if (!result || !Object.is(result.ret, 'OK')) {
                    return;
                }
                let tempSubmitData: any = Util.deepCopy(data[0]);
                if (result.datas && result.datas[0]) {
                    const resultData: any = result.datas[0];
                    if (Object.keys(resultData).length > 0) {
                        let tempData: any = {};
                        Object.keys(resultData).forEach((key: any) => {
                            if (resultData[key] && (key !== "srfuf")) tempData[key] = resultData[key];
                        })
                        Object.assign(tempSubmitData, tempData);
                    }
                    this.submitWFAddiFeature(linkItem, tempSubmitData);
                }
            });
        }else{
            this.submitWFAddiFeature(linkItem, data);
        }
    }

    /**
     * 提交工作流辅助功能
     * 
     * @memberof IBIZSample0021Usr1114865995WFDynaEditView3Base                
     */
    public submitWFAddiFeature(linkItem: any, submitData: any) {
        const that: any = this;
        let tempSubmitData: any = Object.assign(linkItem, { "activedata": submitData });
        let action: string = this.wfAddiFeatureRef[linkItem.type].action;
        if (!action) return;
        if (that.appEntityService && that.appEntityService[action] && that.appEntityService[action] instanceof Function) {
            const tempContext = Util.deepCopy(this.context);
            Object.assign(tempContext, { taskId: linkItem.taskId })
            that.appEntityService[action](tempContext, tempSubmitData).then((response: any) => {
                const { data } = response;
                if (!response || response.status !== 200) {
                    this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: data.message ? data.message : this.$t('app.commonWords.sysException') as string });
                    return;
                }
                AppCenterService.notifyMessage({name:"srfwftodo",action:'appRefresh',data});
                if (this.viewdata) {
                    this.$emit('viewdataschange', [{ ...data }]);
                    this.$emit('close');
                } else if (this.$tabPageExp) {
                    this.$tabPageExp.onClose(this.$route.fullPath);
                }
                this.$Notice.success({ title: '', desc: (this.$t('app.formpage.workflow.submitsuccess') as string) });
            }).catch((error: any) => {
                const { data } = error;
                this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: data.message ? data.message : this.$t('app.commonWords.sysException') as string });
            })
        } else {
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: `${action}暂未实现` });
        }
    }



}
</script>

<style lang='less'>
@import './ibizsample0021-usr1114865995-wfdyna-edit-view3.less';
</style>